
/***************************************/
/******			VAR TO SET        ******/
/***************************************/

DECLARE @Org_Key AS int;
SET @Org_Key = 2;

DECLARE @Language_Code AS nvarchar(30);
SET @Language_Code = 'ENG';
/***************************************/

DECLARE @Translation_User_1 AS nvarchar(200);
DECLARE @Translation_User_2 AS nvarchar(200);
DECLARE @Translation_User_3 AS nvarchar(200);
DECLARE @Translation_User_4 AS nvarchar(200);
DECLARE @Translation_User_5 AS nvarchar(200);
DECLARE @Translation_User_6 AS nvarchar(200);


SET @Translation_User_1 = (SELECT Translation FROM Translation WHERE Mnemonic = 'USER_DISPLAY_FIELD_1' AND Language_Code = @Language_Code AND Organization_Key = @Org_Key);
SET @Translation_User_2 = (SELECT Translation FROM Translation WHERE Mnemonic = 'USER_DISPLAY_FIELD_2' AND Language_Code = @Language_Code AND Organization_Key = @Org_Key);
SET @Translation_User_3 = (SELECT Translation FROM Translation WHERE Mnemonic = 'USER_DISPLAY_FIELD_3' AND Language_Code = @Language_Code AND Organization_Key = @Org_Key);
SET @Translation_User_4 = (SELECT Translation FROM Translation WHERE Mnemonic = 'USER_DISPLAY_FIELD_4' AND Language_Code = @Language_Code AND Organization_Key = @Org_Key);
SET @Translation_User_5 = (SELECT Translation FROM Translation WHERE Mnemonic = 'USER_DISPLAY_FIELD_5' AND Language_Code = @Language_Code AND Organization_Key = @Org_Key);
SET @Translation_User_6 = (SELECT Translation FROM Translation WHERE Mnemonic = 'USER_DISPLAY_FIELD_6' AND Language_Code = @Language_Code AND Organization_Key = @Org_Key);

DECLARE @sql nvarchar(max); 

SET @sql = 'SELECT cat.Category_Name AS [Category],
	   p.Rank_String AS [Rank], 
	   CASE SUBSTRING(Rank_String,1,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''First Name'',
	   CASE SUBSTRING(Rank_String,2,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''Surname'',
	   CASE SUBSTRING(Rank_String,3,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''Initials'',
	   CASE SUBSTRING(Rank_String,4,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''Gender''';

IF @Translation_User_1 <> ''
BEGIN
	SET @sql = @sql +
	', CASE SUBSTRING(Rank_String,5,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''' + @Translation_User_1 + ''''
	
	END

IF @Translation_User_2 <> ''
BEGIN
	SET @sql = @sql +
	', CASE SUBSTRING(Rank_String,6,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''' + @Translation_User_2 + ''''
	
END

IF @Translation_User_3 <> ''
BEGIN
	SET @sql = @sql +
	', CASE SUBSTRING(Rank_String,7,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''' + @Translation_User_3 + ''''
	
END
	
IF @Translation_User_4 <> ''
BEGIN
	SET @sql = @sql +
	', CASE SUBSTRING(Rank_String,8,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''' + @Translation_User_4 + ''''
	
END

IF @Translation_User_5 <> ''
BEGIN
	SET @sql = @sql +
	', CASE SUBSTRING(Rank_String,9,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''' + @Translation_User_5 + ''''
	
END

IF @Translation_User_6 <> ''
BEGIN
	SET @sql = @sql +
	', CASE SUBSTRING(Rank_String,10,1)
		   WHEN ''E'' THEN ''EQUAL''
		   WHEN ''B'' THEN ''BLANK''
		   WHEN ''C'' THEN ''CLOSE''
		   ELSE ''NOT EQUAL''
	   END AS ''' + @Translation_User_6 + ''''
	
END


SET @sql = @sql + 
		',  COUNT(*) AS Total	   
FROM   Org cat with (nolock),
	   Table2 p  with (nolock) left outer join
       Profile ctop with (nolock) on
			     p.List_Profile_Key = ctop.List_Profile_Key
		
WHERE    p.Organization_Key = ' +  CAST(@Org_Key AS nvarchar(100))  + ' AND
		 (ctop.Category_Key = cat.Category_Key OR ctop.Category_key is null)  AND
		 p.Organization_Key = cat.Organization_Key
GROUP BY p.RANK_STRING, cat.Category_Name
ORDER BY cat.Category_Name, Total DESC'




exec (@sql)

